/*
 * BaseStation.cpp
 *
 *  Created on: Aug 26, 2011
 *      Author: ra23501
 */

#include "BaseStation.hpp"

#define ROS_NODE "base_station"

//Public methods
BaseStation::BaseStation(void) :
  nh_(), private_nh_("~")
{
  // init params
  BaseStation::initParams();

  // init subscribers
  BaseStation::initSubscribers();

  // init batteries
  //BaseStation::initBatteries();

  // start base thread
  BaseStation::startBaseThread();

  // start listener thread
  BaseStation::startListenThread();
}

BaseStation::~BaseStation()
{
  // stop all threads
  BaseStation::stopBaseThread();
  BaseStation::stopListenThread();
}

// main function
int main(int argc, char **argv)
{
  // initialize ros node handle
  ros::init(argc, argv, ROS_NODE);

  // print start to log file
  ROS_INFO("Started node %s", ROS_NODE);
  ROS_DEBUG("Started node %s", ROS_NODE);

  // create class instance
  BaseStation base_station;
  MaestroController controller;

  controller.disableAll();

  //controller.initializeSystem();
  //ros::Duration(5).sleep();
  controller.centerUAV();
  //ros::Duration(5).sleep();
  //ROS_ERROR("About to move cart");
  controller.retractArms();

  // ros spin
  ros::spin();

  // print termination to log file
  ROS_INFO("Stopped node %s", ROS_NODE);
  ROS_ERROR("Node stopped");

  // return success
  return (0);
}
