/*
 * BaseStation_state.cpp
 *
 *  Created on: Aug 31, 2011
 *      Author: ra23501
 */

// includes
#include "BaseStation.hpp"

// idle state
void BaseStation::idleState(void)
{
//  int ready;
//  // poll internal batteries to see which are done charging
//  if ((ready = controller.doneCharging()) != NUM_BATTERIES)
//  {
//    for (int i = 0; i < NUM_BATTERIES; i++)
//    {
//      if (allBatteries[i]->location == ready)
//      {
//        readyBatteries.push_back(allBatteries[i]);
//      }
//    }
//  }
  if (all_UAVs_.size())
  {
    base_state_ = LANDING;
  }
}

// landing state
void BaseStation::landingState(void)
{
  //TODO: add code to check for landing
  // can check for translation == 0, or can add to the message to see if it has powered down motors
  if (robot_state_.translation.z == 0)
    base_state_ = CENTERING;
}

// centering state
void BaseStation::centeringState(void)
{
  controller.centerUAV();
  base_state_ = REMOVING_BATTERY;
}

// removing battery state
void BaseStation::removingBatteryState(void)
{
  controller.removeBatteryUAV();
  controller.chargeSpentBattery(openStation);
  for (int i = 0; i < NUM_BATTERIES; i++)
  {
    // update the location of the battery that is now charging
    if (allBatteries[i]->location == -1)
    {
      allBatteries[i]->location = openStation;
      break;
    }
  }
  base_state_ = REPLACING_BATTERY;
}

// replacing battery state
void BaseStation::replacingBatteryState(void)
{
  char ready = readyBatteries.at(0)->location;
  for (int i = 0; i < NUM_BATTERIES; i++)
  {
    // update the location of the battery that will be in the UAV
    if (allBatteries[i]->location == ready)
    {
      allBatteries[i]->location = -1;
      openStation = ready;
      break;
    }
  }
  readyBatteries.erase(readyBatteries.begin());
  controller.getChargedBattery(ready);
  controller.replaceBatteryUAV();
  if (robot_state_.battery_voltage > 12)
    base_state_ = LAUNCHING;
}

// taking off state
void BaseStation::launchingState(void)
{
  //controller.retractArms();
  //TODO: add code to clear UAV for launch
  base_state_ = IDLE;
  UAV_landing_ = false;
}
