/*
 * BaseStation_thread_helpers.cpp
 *
 *  Created on: Sep 6, 2011
 *      Author: ra23501
 */

#include "BaseStation.hpp"

// queries the ros master to obtain a list of all possible nodes to connect to
// and connects to those that have the /uid field, signaling a UAV
void BaseStation::findNodes(void)
{
  std::vector<std::string> nodes;
  std::string name;
  ros::NodeHandle nh;
  std::string param;
  unsigned int diffCount = 0;

  ros::master::getNodes(nodes);
  for (unsigned int i = 0; i < nodes.size(); i++)
  {
    diffCount = 0;
    name = nodes.at(i);

    if (nh.getParam(name + string("/uid"), param))
    {
      for (unsigned int i = 0; i < all_UAVs_.size(); i++)
      {
        if (param.compare(all_UAVs_.at(i)) != 0)
        {
          diffCount++;
        }
      }
      if (diffCount == all_UAVs_.size())
      {
        addNode(param);
      }
    }
  }
}

// adds the node to the list of publishers, as it is a node not previously seen
void BaseStation::addNode(string name)
{
  all_UAVs_.push_back(name);
  land_request_pub_.push_back(nh_.advertise<wpi_msgs::LandRequest>(name + "/land_request", 10, true));
  land_confirm_pub_.push_back(nh_.advertise<wpi_msgs::LandConfirm>(name + "/land_confirm", 10, true));
}

float BaseStation::findRemainingTime(string name) {
  // retrieve data for name
  //    probably have a vector of structs that contain the name and array of voltage data for each UAV
  //            (along with last index to know where the end of it is, as a fixed-length array will be
  //            easier to work with and less computationally intensive)
  //    grab the right one and keep it locally as a pointer until I can make a better decision on local storage/use




  return 1.56;
}
