/*
 * MaestroController_servos.cpp
 *
 *  Created on: Sep 14, 2011
 *      Author: ra23501
 */

#include "MaestroController.hpp"

// takes in any number of servos and sets their targets as specified
// contains testing for if a servo is stalling, stopping it after a defined period of time
int MaestroController::moveServos(short* serial, short* channel, short* value, char numServos)
{
  ros::Rate try_rate(2);
  short curr_pos[numServos];//, prev_pos[numServos];
  //char stall_test[numServos];
  //bool indv_moved[numServos];
  //bool moved = false;
  ROS_ERROR("Moving servo");
  //while (!moved)
  //{
  /*for (int i = 0; i < numServos; i++)
   {
   prev_pos[i] = curr_pos[i];
   }*/
  getChannelValues(serial, channel, curr_pos, numServos);
  for (int i = 0; i < numServos; i++)
  {
    ROS_ERROR("Moving servo %d", i);
    //displayStatus(serial[i]);
    //      if (curr_pos[i] == prev_pos[i] && !indv_moved[i]) // test for stall condition
    //      {
    //        ROS_ERROR("Current position %d is same as previous position %d for servo %d", curr_pos[i], prev_pos[i], i);
    //        if ((++(stall_test[i])) >= STALL_OUT)
    //        {
    //          // modify target by a small amount to let up on stall position
    //          value[i] > curr_pos[i] ? value[i] = curr_pos[i] - 40 : value[i] = curr_pos[i] + 40;
    //          ROS_ERROR("Setting servo to new position %d, currently at %d.", value[i], curr_pos[i]);
    //          ROS_ERROR("Stall value is %d for servo %d", stall_test[i], i);
    //          setTarget(serial[i], value[i], channel[i]);
    //          return i;
    //        }
    //      }
    //      else
    //      {
    //        stall_test[i] = 0;
    //      }
    ros::Rate delay(10);
    if (curr_pos[i] == 0)
      curr_pos[i] = 5600;
    ROS_ERROR("Target is %d, current is %d", value[i], curr_pos[i]);
    int diff = value[i] - curr_pos[i];
    ROS_ERROR("Diff is %d, current %d, target %d", diff, curr_pos[i], value[i]);
    bool neg = false;
    if (diff < 0)
    {
      diff *= -1;
      neg = true;
    }

    if (diff > 200)//&& curr_pos[i] != 0)
    {
      ROS_ERROR("Large change");
      int end = value[i];

      for (int j = 0; j < diff / 200; j++)
      {
        if (neg)
        {
          value[i] = curr_pos[i] - (200 * (j + 1));
        }
        else
        {
          value[i] = curr_pos[i] + (200 * (j + 1));
        }
        ROS_ERROR("In loop %d, target is %d", j, value[i]);
        setTarget(serial[i], value[i], channel[i]);
        delay.sleep();
      }
      value[i] = end;
    }
    setTarget(serial[i], value[i], channel[i]);
    //indv_moved[i] = curr_pos[i] == value[i];
  }
  //moved = true;
  //    for (int i = 0; i < numServos; i++)
  //    {
  //      moved = moved && indv_moved[i];
  //    }
  //try_rate.sleep(); // regulate sample rate to 2 Hz
  //}
  return -1;
}

// set the target of the specified servo with some limit checking
void MaestroController::setTarget(short serial, short value, short channel)
{
  // TODO: change this to fit all servos if needed
  if (value > GWS_MAX)
    value = GWS_MAX;

  if (value < GWS_MIN)
    value = GWS_MIN;

  //  if (value == GWS_MAX || value == GWS_MIN)
  //  {
  //    ROS_ERROR("Bounds hit, setting to limit");
  //  }
  controlTransfer(serial, LIBUSB_REQUEST_TYPE_VENDOR, REQUEST_SET_TARGET, value, channel);
}

// limit the speed of the servo to the specified value
void MaestroController::setSpeed(short serial, short value, short channel)
{
  controlTransfer(MICRO_SERIAL, LIBUSB_REQUEST_TYPE_VENDOR, REQUEST_SET_SERVO_VARIABLE, value, channel);
}

// limit the acceleration of the servo to the specified value
void MaestroController::setAcceleration(short serial, short value, short channel)
{
  controlTransfer(MICRO_SERIAL, LIBUSB_REQUEST_TYPE_VENDOR, REQUEST_SET_SERVO_VARIABLE, value, (short)(channel | 0x80));
}

void MaestroController::disableServo(short serial, short channel)
{
  controlTransfer(serial, LIBUSB_REQUEST_TYPE_VENDOR, REQUEST_SET_TARGET, 0, channel);
}
