/**
 * \file pelican_simulator_callback.cpp
 *
 * \author Brian J. Julian
 *
 * \version 0.1
 *
 * \date 30 Aug 2011
 *
 */


// includes
#include <pelican_simulator.h>


// callback for land request message
void PelicanSimulator::callbackLandRequestMsg(const boost::shared_ptr<wpi_msgs::LandRequest const> &land_request_msg)
{
  mutex_.lock();
  received_land_request_ = true;
  mutex_.unlock();
}


// callback for land confirm message
void PelicanSimulator::callbackLandConfirmMsg(const boost::shared_ptr<wpi_msgs::LandConfirm const> &land_confirm_msg)
{
  mutex_.lock();
  if(land_confirm_msg->confirm)
    {
      received_positive_land_confirm_ = true;
    }
  else
    {
      received_negative_land_confirm_ = true;
    }
  mutex_.unlock();
}
